package com.abc.db;
import java.sql.*;
import java.lang.Exception.*;
import java.util.*;

public class PoolDbManager
{
	static private Hashtable m_Pools =  new Hashtable();
	
	public final static void Init( String sDriverName ) 
		throws ClassNotFoundException
	{
		Class.forName( sDriverName );
	}

	public final static Connection getConnection( String sSystemUrl ) 
		throws SQLException
	{
		return getConnection( sSystemUrl, null, null );
/*		PoolOfConnections pool = null;
		synchronized( m_Pools )
		{
			pool = (PoolOfConnections)m_Pools.get( sSystemUrl );
			if( pool == null )
			{	
				pool = new PoolOfConnections( sSystemUrl, null, null );
				m_Pools.put( sSystemUrl, pool );
			}
		}
		return pool.getConnection();
*/
	}
	
	public final static void initPool( String sSystemUrl, String sUser, String sPassword )
	{
		PoolOfConnections pool = null;
		String sKey = sSystemUrl;
		if( sUser != null )
			sKey += sUser;
		if( sPassword != null )
			sKey += sPassword;
		synchronized( m_Pools )
		{
			pool = (PoolOfConnections)m_Pools.get( sKey );
			if( pool == null )
			{	
				pool = new PoolOfConnections( sSystemUrl, sUser, sPassword );
				m_Pools.put( sKey, pool );
			}
		}
	}
												 
	public final static Connection getConnection( String sSystemUrl, String sUser, String sPassword )  
		throws SQLException
	{
		PoolOfConnections pool = null;
		String sKey = sSystemUrl;
		if( sUser != null )
			sKey += sUser;
		if( sPassword != null )
			sKey += sPassword;
		synchronized( m_Pools )
		{
			pool = (PoolOfConnections)m_Pools.get( sKey );
			if( pool == null )
			{	
				pool = new PoolOfConnections( sSystemUrl, sUser, sPassword );
				m_Pools.put( sKey, pool );
			}
		}
		return pool.getConnection();
	}
	
	public final static Hashtable getPool() {
		return m_Pools;
	}
	
	public final static PoolOfConnections getPool( String sSystemUrl, String sUser, String sPassword )  
	{
		String sKey = sSystemUrl;
		if( sUser != null )
			sKey += sUser;
		if( sPassword != null )
			sKey += sPassword;
		return (PoolOfConnections)m_Pools.get( sKey );
	}
	
	public final static void initializePool( String sSystemUrl, String sUser, String sPassword ) 
		throws SQLException
	{
		Connection con = getConnection( sSystemUrl, sUser, sPassword );
		con.close();
	}
}
