package com.abc.dbpoolservlet;

import javax.servlet.http.*;
import javax.servlet.*;
import java.io.*;
import java.util.*;
import java.sql.*;
import com.abc.templates.*;

public class PoolServlet extends HttpServlet
{
	static TemplateLoader	m_TemplateLoader;
						   
	public final void init(ServletConfig config)
	{
		try
		{
			String sTemplatePath = config.getInitParameter("TemplatePath");
			m_TemplateLoader = new TemplateLoader();
			m_TemplateLoader.setPath( sTemplatePath, "config.txt");
		}
		catch( Exception e )
		{
			System.err.println("Auto throws exception in init - " + e.getMessage() );
			e.printStackTrace();
			m_TemplateLoader =  null;
		}
	}

	protected final void doGet (HttpServletRequest req,HttpServletResponse res)
        throws ServletException, IOException    
	{
		doSomething( req, res );
	}
	protected final void doPost (HttpServletRequest req,HttpServletResponse res)
        throws ServletException, IOException    
	{
		doSomething( req, res );
	}
	
	protected final void doSomething (HttpServletRequest req,HttpServletResponse res)
        throws ServletException, IOException      
	{
		String sPathInfo=req.getPathInfo();
		String sFunctionName=getFunctionName(sPathInfo);
		if( sPathInfo != null )
			sPathInfo=sPathInfo.substring(sFunctionName.length()+1);
		HtmlWriter out = null;
		IHtmlForm form = null;
		try
		{
			out = new HtmlWriter( res, true, m_TemplateLoader.getSubstitutor() );
			if( sFunctionName.compareTo("update") == 0 ) 
				form = new UpdateForm();
			else 
				form = new PoolInfo( );
			form.writeToHtml( req, out, sPathInfo );	
		}
		finally
		{
			if( out != null )
				out.close();	
		}
	}
	
	static String getFunctionName(String sPathInfo)
	{
		int i;
		if(sPathInfo!=null)
		{
			if(sPathInfo.length()==0)return "";
			i=sPathInfo.indexOf('/',1);
			if(i!=-1)return sPathInfo.substring(1,i);
			else return sPathInfo.substring(1,sPathInfo.length());
		}
		return "";
	}	
}
