package com.abc.dbpoolservlet;

import com.abc.templates.*;
import javax.servlet.http.*;
import javax.servlet.*;
import java.io.*;
import java.util.*;
import com.abc.db.*;

public class UpdateForm implements IHtmlForm
{
	Template template = null;
	int m_iNum;
	
	public boolean writeToHtml(HttpServletRequest req, HtmlWriter out, String sPath )
	{
		try
		{
			template = PoolServlet.m_TemplateLoader.getTemplate( "change" );
			String sMethod = PoolServlet.getFunctionName( sPath );
			m_iNum = Integer.parseInt( req.getParameterValues("pool")[0] );
			out.addSubstitute( "Num", Integer.toString( m_iNum ) );
			if( sMethod.compareTo("submit") == 0 )
				return submit( req, out );
			Hashtable pool  = PoolDbManager.getPool();
			Enumeration e = pool.elements();
			while( e.hasMoreElements() )
			{
				m_iNum--;
				if( m_iNum == -1 )
					break;
				e.nextElement();
			}
			if( !e.hasMoreElements() )
				return redirect( out );		//need to send back.
			PoolOfConnections p = (PoolOfConnections)e.nextElement();
			out.addSubstitute("User", p.getUser() );
			out.addSubstitute("System", p.getSystem() );
			template.getControl("Min").setValue( Integer.toString( p.getMin() ) );
			template.getControl("Max").setValue( Integer.toString( p.getMax() ) );
			template.writeToHtml( out );
		}
		catch( Exception e )
		{
		}
		finally
		{
			if( template != null )
				template.destroy();
		}
		return true;
	}

		private boolean submit( HttpServletRequest req, HtmlWriter out )
			throws Exception
		{
			if( template.readFromHtml(req, new StandartValidator()) )
			{
				Hashtable pool  = PoolDbManager.getPool();				
				Enumeration e = pool.elements();
				while( e.hasMoreElements() )
				{
					m_iNum--;
					if( m_iNum == -1 )
						break;
					e.nextElement();
				}
				if( !e.hasMoreElements() )
					return redirect( out );		//need to send back.
				PoolOfConnections p = (PoolOfConnections)e.nextElement();
				p.setMin( Integer.parseInt( template.getControl("Min").getValue() ));
				p.setMax( Integer.parseInt(  template.getControl("Max").getValue() ));
				return redirect( out );
			}
			template.writeToHtml( out );
			return true;
		}
		
		private boolean redirect( HtmlWriter out )
			throws Exception
		{
			String sPath = PoolServlet.m_TemplateLoader.getSubstitute( "ServletPath");		
			out.getResponse().sendRedirect( sPath );
			return true;
		}
}
